<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVaryasyon ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVaryasyon
 * @subpackage Arrays
 */
class ArrayOfVaryasyon extends AbstractStructArrayBase
{
    /**
     * The Varyasyon
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Varyasyon[]
     */
    public $Varyasyon;
    /**
     * Constructor method for ArrayOfVaryasyon
     * @uses ArrayOfVaryasyon::setVaryasyon()
     * @param \StructType\Varyasyon[] $varyasyon
     */
    public function __construct(array $varyasyon = array())
    {
        $this
            ->setVaryasyon($varyasyon);
    }
    /**
     * Get Varyasyon value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Varyasyon[]|null
     */
    public function getVaryasyon()
    {
        return isset($this->Varyasyon) ? $this->Varyasyon : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVaryasyon method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVaryasyon method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVaryasyonForArrayConstraintsFromSetVaryasyon(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVaryasyonVaryasyonItem) {
            // validation for constraint: itemType
            if (!$arrayOfVaryasyonVaryasyonItem instanceof \StructType\Varyasyon) {
                $invalidValues[] = is_object($arrayOfVaryasyonVaryasyonItem) ? get_class($arrayOfVaryasyonVaryasyonItem) : sprintf('%s(%s)', gettype($arrayOfVaryasyonVaryasyonItem), var_export($arrayOfVaryasyonVaryasyonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Varyasyon property can only contain items of type \StructType\Varyasyon, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Varyasyon value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Varyasyon[] $varyasyon
     * @return \ArrayType\ArrayOfVaryasyon
     */
    public function setVaryasyon(array $varyasyon = array())
    {
        // validation for constraint: array
        if ('' !== ($varyasyonArrayErrorMessage = self::validateVaryasyonForArrayConstraintsFromSetVaryasyon($varyasyon))) {
            throw new \InvalidArgumentException($varyasyonArrayErrorMessage, __LINE__);
        }
        if (is_null($varyasyon) || (is_array($varyasyon) && empty($varyasyon))) {
            unset($this->Varyasyon);
        } else {
            $this->Varyasyon = $varyasyon;
        }
        return $this;
    }
    /**
     * Add item to Varyasyon value
     * @throws \InvalidArgumentException
     * @param \StructType\Varyasyon $item
     * @return \ArrayType\ArrayOfVaryasyon
     */
    public function addToVaryasyon(\StructType\Varyasyon $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Varyasyon) {
            throw new \InvalidArgumentException(sprintf('The Varyasyon property can only contain items of type \StructType\Varyasyon, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Varyasyon[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Varyasyon|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Varyasyon|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Varyasyon|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Varyasyon|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Varyasyon|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Varyasyon
     */
    public function getAttributeName()
    {
        return 'Varyasyon';
    }
}
