<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveTakimUrunRequestV2 StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SaveTakimUrunRequestV2
 * @subpackage Structs
 */
class SaveTakimUrunRequestV2 extends AbstractStructBase
{
    /**
     * The KampanyaAdi
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $KampanyaAdi;
    /**
     * The KampanyaBaslangic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $KampanyaBaslangic;
    /**
     * The KampanyaBitis
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $KampanyaBitis;
    /**
     * The TakimUrunList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfTakimUrunV2
     */
    public $TakimUrunList;
    /**
     * The UrunKartiId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $UrunKartiId;
    /**
     * The UrunKartiTedarikciKodu
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UrunKartiTedarikciKodu;
    /**
     * Constructor method for SaveTakimUrunRequestV2
     * @uses SaveTakimUrunRequestV2::setKampanyaAdi()
     * @uses SaveTakimUrunRequestV2::setKampanyaBaslangic()
     * @uses SaveTakimUrunRequestV2::setKampanyaBitis()
     * @uses SaveTakimUrunRequestV2::setTakimUrunList()
     * @uses SaveTakimUrunRequestV2::setUrunKartiId()
     * @uses SaveTakimUrunRequestV2::setUrunKartiTedarikciKodu()
     * @param string $kampanyaAdi
     * @param string $kampanyaBaslangic
     * @param string $kampanyaBitis
     * @param \ArrayType\ArrayOfTakimUrunV2 $takimUrunList
     * @param int $urunKartiId
     * @param string $urunKartiTedarikciKodu
     */
    public function __construct($kampanyaAdi = null, $kampanyaBaslangic = null, $kampanyaBitis = null, \ArrayType\ArrayOfTakimUrunV2 $takimUrunList = null, $urunKartiId = null, $urunKartiTedarikciKodu = null)
    {
        $this
            ->setKampanyaAdi($kampanyaAdi)
            ->setKampanyaBaslangic($kampanyaBaslangic)
            ->setKampanyaBitis($kampanyaBitis)
            ->setTakimUrunList($takimUrunList)
            ->setUrunKartiId($urunKartiId)
            ->setUrunKartiTedarikciKodu($urunKartiTedarikciKodu);
    }
    /**
     * Get KampanyaAdi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getKampanyaAdi()
    {
        return isset($this->KampanyaAdi) ? $this->KampanyaAdi : null;
    }
    /**
     * Set KampanyaAdi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $kampanyaAdi
     * @return \StructType\SaveTakimUrunRequestV2
     */
    public function setKampanyaAdi($kampanyaAdi = null)
    {
        // validation for constraint: string
        if (!is_null($kampanyaAdi) && !is_string($kampanyaAdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kampanyaAdi, true), gettype($kampanyaAdi)), __LINE__);
        }
        if (is_null($kampanyaAdi) || (is_array($kampanyaAdi) && empty($kampanyaAdi))) {
            unset($this->KampanyaAdi);
        } else {
            $this->KampanyaAdi = $kampanyaAdi;
        }
        return $this;
    }
    /**
     * Get KampanyaBaslangic value
     * @return string|null
     */
    public function getKampanyaBaslangic()
    {
        return $this->KampanyaBaslangic;
    }
    /**
     * Set KampanyaBaslangic value
     * @param string $kampanyaBaslangic
     * @return \StructType\SaveTakimUrunRequestV2
     */
    public function setKampanyaBaslangic($kampanyaBaslangic = null)
    {
        // validation for constraint: string
        if (!is_null($kampanyaBaslangic) && !is_string($kampanyaBaslangic)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kampanyaBaslangic, true), gettype($kampanyaBaslangic)), __LINE__);
        }
        $this->KampanyaBaslangic = $kampanyaBaslangic;
        return $this;
    }
    /**
     * Get KampanyaBitis value
     * @return string|null
     */
    public function getKampanyaBitis()
    {
        return $this->KampanyaBitis;
    }
    /**
     * Set KampanyaBitis value
     * @param string $kampanyaBitis
     * @return \StructType\SaveTakimUrunRequestV2
     */
    public function setKampanyaBitis($kampanyaBitis = null)
    {
        // validation for constraint: string
        if (!is_null($kampanyaBitis) && !is_string($kampanyaBitis)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kampanyaBitis, true), gettype($kampanyaBitis)), __LINE__);
        }
        $this->KampanyaBitis = $kampanyaBitis;
        return $this;
    }
    /**
     * Get TakimUrunList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfTakimUrunV2|null
     */
    public function getTakimUrunList()
    {
        return isset($this->TakimUrunList) ? $this->TakimUrunList : null;
    }
    /**
     * Set TakimUrunList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfTakimUrunV2 $takimUrunList
     * @return \StructType\SaveTakimUrunRequestV2
     */
    public function setTakimUrunList(\ArrayType\ArrayOfTakimUrunV2 $takimUrunList = null)
    {
        if (is_null($takimUrunList) || (is_array($takimUrunList) && empty($takimUrunList))) {
            unset($this->TakimUrunList);
        } else {
            $this->TakimUrunList = $takimUrunList;
        }
        return $this;
    }
    /**
     * Get UrunKartiId value
     * @return int|null
     */
    public function getUrunKartiId()
    {
        return $this->UrunKartiId;
    }
    /**
     * Set UrunKartiId value
     * @param int $urunKartiId
     * @return \StructType\SaveTakimUrunRequestV2
     */
    public function setUrunKartiId($urunKartiId = null)
    {
        // validation for constraint: int
        if (!is_null($urunKartiId) && !(is_int($urunKartiId) || ctype_digit($urunKartiId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($urunKartiId, true), gettype($urunKartiId)), __LINE__);
        }
        $this->UrunKartiId = $urunKartiId;
        return $this;
    }
    /**
     * Get UrunKartiTedarikciKodu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrunKartiTedarikciKodu()
    {
        return isset($this->UrunKartiTedarikciKodu) ? $this->UrunKartiTedarikciKodu : null;
    }
    /**
     * Set UrunKartiTedarikciKodu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $urunKartiTedarikciKodu
     * @return \StructType\SaveTakimUrunRequestV2
     */
    public function setUrunKartiTedarikciKodu($urunKartiTedarikciKodu = null)
    {
        // validation for constraint: string
        if (!is_null($urunKartiTedarikciKodu) && !is_string($urunKartiTedarikciKodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urunKartiTedarikciKodu, true), gettype($urunKartiTedarikciKodu)), __LINE__);
        }
        if (is_null($urunKartiTedarikciKodu) || (is_array($urunKartiTedarikciKodu) && empty($urunKartiTedarikciKodu))) {
            unset($this->UrunKartiTedarikciKodu);
        } else {
            $this->UrunKartiTedarikciKodu = $urunKartiTedarikciKodu;
        }
        return $this;
    }
}
