<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UrunBarkod StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UrunBarkod
 * @subpackage Structs
 */
class UrunBarkod extends AbstractStructBase
{
    /**
     * The Barkod
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Barkod;
    /**
     * The BarkodGrupID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $BarkodGrupID;
    /**
     * Constructor method for UrunBarkod
     * @uses UrunBarkod::setBarkod()
     * @uses UrunBarkod::setBarkodGrupID()
     * @param string $barkod
     * @param int $barkodGrupID
     */
    public function __construct($barkod = null, $barkodGrupID = null)
    {
        $this
            ->setBarkod($barkod)
            ->setBarkodGrupID($barkodGrupID);
    }
    /**
     * Get Barkod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBarkod()
    {
        return isset($this->Barkod) ? $this->Barkod : null;
    }
    /**
     * Set Barkod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $barkod
     * @return \StructType\UrunBarkod
     */
    public function setBarkod($barkod = null)
    {
        // validation for constraint: string
        if (!is_null($barkod) && !is_string($barkod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($barkod, true), gettype($barkod)), __LINE__);
        }
        if (is_null($barkod) || (is_array($barkod) && empty($barkod))) {
            unset($this->Barkod);
        } else {
            $this->Barkod = $barkod;
        }
        return $this;
    }
    /**
     * Get BarkodGrupID value
     * @return int|null
     */
    public function getBarkodGrupID()
    {
        return $this->BarkodGrupID;
    }
    /**
     * Set BarkodGrupID value
     * @param int $barkodGrupID
     * @return \StructType\UrunBarkod
     */
    public function setBarkodGrupID($barkodGrupID = null)
    {
        // validation for constraint: int
        if (!is_null($barkodGrupID) && !(is_int($barkodGrupID) || ctype_digit($barkodGrupID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($barkodGrupID, true), gettype($barkodGrupID)), __LINE__);
        }
        $this->BarkodGrupID = $barkodGrupID;
        return $this;
    }
}
